unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

type
  TTestItem = class
    Title: String;
    constructor Create(ATitle: String);
  end;
  
  constructor TTestItem.Create(ATitle: String);
  begin 
    Title := ATitle;
  end;
  
  
{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  L: TStringList;
begin
  L := TStringList.Create;
  try
    L.AddObject('one', TTestItem.Create('ONE'));
    L.AddObject('two', TTestItem.Create('TWO'));
    L.AddObject('three', TTestItem.Create('THREE'));
    Combobox1.Items.Assign(L);
  finally
    L.Free;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to Combobox1.Items.Count-1 do
    TTestItem(Combobox1.Items.Objects[i]).Free;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  idx: Integer;
begin
  idx := Combobox1.ItemIndex;
  if idx = -1 then
    Caption := '-'
  else
    Caption := Combobox1.Items[idx] + ' - ' + TTestItem(Combobox1.Items.Objects[idx]).Title;
end;

end.

